=== debian/changelog ===
td (1.8.0+git20240817.9b6ff58+dfsg2-1) unstable; urgency=medium

  * Regenerate orig tarball.
  * debian/rules: Add get-orig-source target. This allows rebuild the
    orig tarball without uscan of the exact upstream Git revision specified
    in d/changelog.

 -- Mike Gabriel <sunweaver@debian.org>  Wed, 04 Dec 2024 10:52:00 +0100

td (1.8.0+git20240817.9b6ff58+dfsg-5) unstable; urgency=medium

  * debian/patches:
    + Rebase patches 0001, 1001, 2001.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 03 Dec 2024 22:04:34 +0100

td (1.8.0+git20240817.9b6ff58+dfsg-4) unstable; urgency=medium

  * debian/control:
    + Use versioned B-D: libsqlcipher-dev (>= 4.6.1-2~). Only that version in
      Debian provides built-in fts5 support as required by libtd.

 -- Mike Gabriel <sunweaver@debian.org>  Tue, 03 Dec 2024 20:29:16 +0100

td (1.8.0+git20240817.9b6ff58+dfsg-3) unstable; urgency=medium

  * Upload to unstable as is.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 02 Dec 2024 21:18:05 +0100

td (1.8.0+git20240817.9b6ff58+dfsg-2) experimental; urgency=medium

  * Upload to experimental.

  [ Cosima Neidahl ]
  * debian: Apply patches to only install shared libs & fix tests. This
    adds the following patches:
    + 0001-Remove-tdapi-tdclient-dynamic-building.patch
    + 0002-Install-only-BUILD_SHARED_LIBS-matching.patch
    + 0003-Separate-install-variables.patch
  * debian/rules: Enable building everything as shared library.

  [ Mike Gabriel ]
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 02 Dec 2024 15:40:04 +0100
