=== debian/control ===
Source: td
Section: libs
Priority: optional
Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
Uploaders: Mike Gabriel <sunweaver@debian.org>,
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               gperf,
               libssl-dev,
               libsqlcipher-dev (>= 4.6.1-2~),
               php,
               zlib1g-dev
Standards-Version: 4.6.2
Homepage: https://github.com/tdlib/td
Vcs-Browser: https://salsa.debian.org/debian/td/
Vcs-Git: https://salsa.debian.org/debian/td.git

Package: libtd-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libtdjson1.8.27 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: libtd-doc
Description: telegram database library (development headers)
 TDLib (Telegram Database Library) is a cross-platform, fully functional
 Telegram client. This library helps third-party developers create their
 own custom apps using the Telegram platform.
 .
 This package contains the development files.

Package: libtd-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: telegram database library (development documentation)
 TDLib (Telegram Database Library) is a cross-platform, fully functional
 Telegram client. This library helps third-party developers create their
 own custom apps using the Telegram platform.
 .
 This package contains the documentation.

Package: libtdjson1.8.27
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libtd-doc
Description: telegram database library
 TDLib (Telegram Database Library) is a cross-platform, fully functional
 Telegram client. This library helps third-party developers create their
 own custom apps using the Telegram platform.
