=== debian/watch ===
# Compulsory line, this is a version 4 file.
version=4

# Directly from Git, latest upstream release:
#opts="mode=git" https://github.com/tdlib/td.git \
#    refs/tags/v([\d\.]+)

# Upstream Git snapshot
opts="mode=git,pgpmode=none,pretty=1.8.0+git%cd.%h,repacksuffix=+dfsg2,dversionmangle=s/\+dfsg2//" \
https://github.com/tdlib/td.git \
heads/master
